package com.kexun.controller;

//import ch.qos.logback.core.rolling.helper.FileStoreUtil;
//import ch.qos.logback.core.util.FileUtil;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.kexun.common.FileUploadUtil;
import com.kexun.common.utils.Result;
import com.kexun.entity.CustomizedModel;
import com.kexun.entity.SysUser;
import com.kexun.service.CustomizedModelService;
import com.kexun.service.impl.FileServiceImpl;
import com.kexun.utils.DateUtils;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.util.FileCopyUtils;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Date;
import java.util.List;
import java.util.Map;

/*
新添加
 * 目标：实现单笔/批量导入
 * 目前：已实现
 */

@RestController
@RequestMapping("/admin/up")
@Slf4j
public class UploadController {

    @Autowired
    FileServiceImpl fileService;

    @Autowired
    private CustomizedModelService customizedModelService;
    /**
     * 文件目录，解析后的文件目录
     */
    @Value("${report.file.xmlSourcePath}")
    private String xmlSourcePath;
    /**
     * 文件目录，解析后的文件目录
     */
    @Value("${report.file.xmlTargetPath}")
    private String xmlTargetPath;

    /**
     * 模型文件目标文件
     */
    @Value("${report.file.modelTargetPath}")
    private String modelPath;

    /**
     * 存放JSON文件路径
     */
    @Value("${report.file.jsonTargetPath}")
    private String jsonTargetPath;

    /**
     * 上传xml及JSON文件
     */
    @PostMapping("/uploadUi")
    public Result uploadUi(@RequestParam("files") MultipartFile[] files, @RequestParam("customerName") String customerName,
                           @RequestParam("headInfId") String headInfId) {
        if (files.length > 0) {
            String date = DateUtils.format(new Date(), DateUtils.YYYYMMDD);
            for (MultipartFile file : files) {
                String fileName = customerName + "_" + headInfId + "_" + file.getOriginalFilename();
                try {
                    String filePath = "";
                    if (fileName.endsWith("xml")) {
                        filePath = xmlSourcePath + date;
                        File mkdir = new File(filePath);
                        if (!mkdir.exists()) {
                            mkdir.mkdirs();
                        }
                    } else {
                        filePath = jsonTargetPath + date;
                        File mkdir = new File(filePath);
                        if (!mkdir.exists()) {
                            mkdir.mkdirs();
                        }
                    }
                    //定义输出流，将文件写入硬盘
                    FileOutputStream os = new FileOutputStream(filePath + File.separator + fileName);
                    InputStream in = file.getInputStream();
                    int b = 0;
                    while((b = in.read()) != -1) { //读取文件
                        os.write(b);
                    }
                    os.flush(); //关闭流
                    in.close();
                    os.close();

                } catch (Exception e) {
                    e.printStackTrace();
                    return new Result(401, "失败");
                }
            }
            return Result.success("成功", 200);
        } else {
            return Result.success("失败", 201);
        }

    }

    /**
     * 上传文件 模型及解析文件均在此
     * upFilePath + "/" + sysUser.getUserName() + "/" + fullFileName是上传文件路径
     * fileName是对文件命名
     */
    @PostMapping("/uploadMod")
//    @ResponseBody
    public Result uploadMod(@RequestParam Integer index, @RequestParam MultipartFile chunk, @RequestParam String name, @RequestParam Integer chunksLength, @RequestParam String uid
            , @RequestParam String customerName,
                            @RequestParam String headInfId, @RequestParam String fileNameModel, @RequestParam String output_list, SysUser sysUser
    ) throws IOException {
        String date = DateUtils.format(new Date(), DateUtils.YYYYMMDD);

//        System.out.println("asdflhlkfasawe");
        String fileName = customerName + "_" + headInfId + "_" + name;

        String upFilePath = "";
        if (fileNameModel.equals("1")) {
            upFilePath = modelPath + date;
        } else if (fileName.endsWith("xml")) {
            upFilePath = xmlSourcePath + date;
        } else {
            upFilePath = jsonTargetPath + date;
        }
        log.info("上传文件的路径是:{}", upFilePath + date);

        String fullFileName = String.join("-", new String[]{fileName, uid, index + "", "."});
//        String filePath = upFilePath + "/" + sysUser.getUserName() + "/" + fileName + "." ;
        log.info("filename:" + fullFileName);
        File dir = new File(upFilePath + "/" + sysUser.getUserName() + "/");

        if (!dir.exists()) {
            dir.mkdirs();
        }
        File file = new File(upFilePath + "/" + sysUser.getUserName() + "/" + fullFileName);
        FileCopyUtils.copy(chunk.getInputStream(), new FileOutputStream(file));
        FileUploadUtil.put(uid, index, chunksLength, fullFileName, upFilePath + "/" + sysUser.getUserName() + "/");
        // 检测所有文件是否上传完成
        boolean isAllChunksUploaded = FileUploadUtil.isAllChunksUploaded(uid);
        //当前步骤这一步一定完成
        try {
            if (isAllChunksUploaded) {
                FileUploadUtil.mergeChunks(fileName, uid);
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new RuntimeException(ex.getMessage());
        }


        return Result.success();
    }

    @GetMapping("list")
    public Result list(String modelName) {
        QueryWrapper<CustomizedModel> w = new QueryWrapper<>();
        if (!StringUtils.isEmpty(modelName)) {
            w.like("model_name", modelName);
        }

        List<CustomizedModel> list = customizedModelService.list(w);
        return Result.success("ok", list);
    }
}
