package com.kexun.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 防欺诈警示信息 
 * </p>
 *
 * @author lgs
 * @since 2023-05-30
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_head_fraud")
@ApiModel(value="HeadFraudEntity对象", description="防欺诈警示信息 ")
public class HeadFraudEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "姓名")
    @TableField("name")
    private String name;

    @ApiModelProperty(value = "证件类型代码")
    @TableField("id_type_code")
    private String idTypeCode;

    @ApiModelProperty(value = "证件类型描述")
    @TableField("id_type_desc")
    private String idTypeDesc;

    @ApiModelProperty(value = "证件号码")
    @TableField("id_num")
    private String idNum;

    @ApiModelProperty(value = "防欺诈警示标志代码")
    @TableField("sign_coode")
    private String signCoode;

    @ApiModelProperty(value = "防欺诈警示标志描述")
    @TableField("sign_desc")
    private String signDesc;

    @ApiModelProperty(value = "防欺诈警示联系电话")
    @TableField("tel")
    private String tel;

    @ApiModelProperty(value = "防欺诈警示生效日期")
    @TableField("eff_date")
    private String effDate;

    @ApiModelProperty(value = "防欺诈警示截止日期")
    @TableField("end_date")
    private String endDate;


}
