package com.kexun.entity;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 住房公积金参缴记录
 * </p>
 *
 * @author lgs
 * @since 2023-06-13
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_pub_housing_fund")
@ApiModel(value="PubHousingFundEntity对象", description="住房公积金参缴记录")
public class PubHousingFundEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "姓名")
    @TableField("name")
    private String name;

    @ApiModelProperty(value = "证件号码")
    @TableField("id_num")
    private String idNum;

    @ApiModelProperty(value = "参缴地代码")
    @TableField("address_code")
    private String addressCode;

    @ApiModelProperty(value = "参缴地描述")
    @TableField("address_desc")
    private String addressDesc;

    @ApiModelProperty(value = "参缴日期")
    @TableField("pay_date")
    private String payDate;

    @ApiModelProperty(value = "缴费状态代码")
    @TableField("status_code")
    private String statusCode;

    @ApiModelProperty(value = "缴费状态描述")
    @TableField("status_desc")
    private String statusDesc;

    @ApiModelProperty(value = "初缴月份")
    @TableField("begin_month")
    private String beginMonth;

    @ApiModelProperty(value = "缴至月份")
    @TableField("end_month")
    private String endMonth;

    @ApiModelProperty(value = "单位缴存比例")
    @TableField("com_proportion")
    private String comProportion;

    @ApiModelProperty(value = "个人缴存比例")
    @TableField("pe_proportion")
    private String peProportion;

    @ApiModelProperty(value = "月缴存额")
    @TableField("month_money")
    private BigDecimal monthMoney;

    @ApiModelProperty(value = "缴费单位")
    @TableField("company")
    private String company;

    @ApiModelProperty(value = "信息更新日期")
    @TableField("update_date")
    private String updateDate;


}
