package com.kexun.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;

/**
 * 报文文件Entity
 */
@TableName(value = "report_file")
@Data
public class ReportFileEntity extends BaseEntity implements Serializable {

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    /**
     * 报告头信息表id
     */
    @TableField(value = "head_inf_id")
    private Long headInfId;

    /**
     * 报告编码
     */
    @TableField(value = "rpt_no")
    private String rptNo;

    /**
     * 业务申请ID
     */
    @TableField(value = "business_id")
    private Long businessId;

    /**
     * 业务申请编号
     */
    @TableField(value = "business_num")
    private String businessNum;

    /**
     * 文件名
     */
    @TableField(value = "file_name")
    private String fileName;

    /**
     * 文件类型0-源文件:1-解析后xml文件;2-解析后的json文件;3-模型文件
     */
    @TableField(value = "file_type")
    private String fileType;

    /**
     * 文件类型描述
     */
    @TableField(value = "file_type_desc")
    private String fileTypeDesc;

    /**
     * 文件路径
     */
    @TableField(value = "file_path")
    private String filePath;

    /**
     * 文件是否有效开关
     */
    @TableField(value = "file_on_off")
    private String fileOnOff;


}
