package com.kexun.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 公开信息概要
 * </p>
 *
 * @author lgs
 * @since 2023-06-09
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_smry_public")
@ApiModel(value="SmryPublicEntity对象", description="公开信息概要")
public class SmryPublicEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "姓名")
    @TableField("name")
    private String name;

    @ApiModelProperty(value = "证件号码")
    @TableField("id_num")
    private String idNum;

    @ApiModelProperty(value = "信息类型代码")
    @TableField("info_type_code")
    private String infoTypeCode;

    @ApiModelProperty(value = "信息类型描述")
    @TableField("info_type_desc")
    private String infoTypeDesc;

    @ApiModelProperty(value = "笔数")
    @TableField("count")
    private Integer count;


}
