package com.kexun.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.kexun.entity.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 最近5年内的历史表现信息
 * </p>
 *
 * @author lgs
 * @since 2023-06-12
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("cr_trs_five_year")
@ApiModel(value="TrsFiveYearEntity对象", description="最近5年内的历史表现信息")
public class TrsFiveYearEntity extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "报告头信息表id")
    @TableField("head_inf_id")
    private Long headInfId;

    @ApiModelProperty(value = "报告编码")
    @TableField("rpt_no")
    private String rptNo;

    @ApiModelProperty(value = "姓名")
    @TableField("name")
    private String name;

    @ApiModelProperty(value = "证件号码")
    @TableField("id_num")
    private String idNum;

    @ApiModelProperty(value = "账户编号")
    @TableField("acct_no")
    private String acctNo;

    @ApiModelProperty(value = "起始年月")
    @TableField("start_year_month")
    private String startYearMonth;

    @ApiModelProperty(value = "截止年月")
    @TableField("end_year_month")
    private String endYearMonth;

    @ApiModelProperty(value = "月数")
    @TableField("mon_num")
    private Integer monNum;


}
