package com.kexun.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.Setter;

/**
 * Description: 日志业务类型
 *
 * @author lgs
 * @date 2023/05/23
 */

@AllArgsConstructor
@Getter
public enum BusinessTypeEnum {

    /**
     * 产品修改
     */
    PRODUCT("1","产品修改"),
    /**
     * 合作方修改
     */
    COOPERATOR("2","合作方修改");


    /**
     * 类别码
     */
    private String code;

    /**
     * 类别名称
     */
    private String name;

    /**
     * 根据code查找
     * @param code 枚举code
     * @return 枚举对象
     */
    public static BusinessTypeEnum findEnumByCode(String code) {
        for (BusinessTypeEnum statusEnum : BusinessTypeEnum.values()) {
            if (statusEnum.getCode().equals(code)) {
                //如果需要直接返回name则更改返回类型为String,return statusEnum.name;
                return statusEnum;
            }
        }
        throw new IllegalArgumentException("code is invalid");
    }

    /**
     * 根据name查找
     * @param name 枚举name
     * @return 枚举对象
     */
    public static BusinessTypeEnum findEnumByName(String name) {
        for (BusinessTypeEnum statusEnum : BusinessTypeEnum.values()) {
            if (statusEnum.getName().equals(name)) {
                //如果需要直接返回code则更改返回类型为String,return statusEnum.code;
                return statusEnum;
            }
        }
        throw new IllegalArgumentException("name is invalid");
    }


}
