package com.kexun.factory;

import com.baomidou.mybatisplus.extension.service.IService;
import com.kexun.entity.IBaseEntity;
import com.kexun.model.xml.IXmlBase;
import com.kexun.service.field.IBaseFieldPackageJsonService;
import com.kexun.service.xml.IHandleXmlBaseService;
import com.kexun.service.xml.IHandleXmlSpecService;
import lombok.Builder;
import lombok.Data;

import java.util.Map;

/**
 * Description:处理解析xml报文所需要的Bean信息
 *
 * @author lgs
 * @date 2023/05/25
 */
@Data
@Builder
public class HandleXmlFactoryBean {

    /**
     * 所属信息段一类
     */
    private String firstType;

    /**
     * 所属信息段二类
     */
    private String secondType;

    /**
     * 所属信息段三类
     */
    private String thirdType;

    /**
     * 对应的xml的node节点名
     */
    private String xmlNodeName;

    /**
     * node节点类型 normal:正常类型 list:类型 compose:组合类型
     */
    private String nodeType;

    /**
     * 对应的xml的node需要转成JavaBean
     */
    private Class<? extends IXmlBase> modelBean;

    /**
     * 对应xml信息段的service处理类
     */
    private IHandleXmlBaseService reportXmlBaseService;

    /**
     * xml信息对应的相关表保存的service
     */
    private IService service;

    /**
     * 信息段对应的实体类
     */
    private Class<? extends IBaseEntity> baseEntity;

    /**
     * 对xml信息段进行特殊处理,主要是对json对应的JavaBean和Entity对应的bean不一致
     */
    private IHandleXmlSpecService specService;
    /**
     * 其它额外参数
     */
    private Map<String,String> paramMap;

    /**
     * 组装基础字段的JSON处理类
     */
    private IBaseFieldPackageJsonService baseFieldPackageJsonService;

    /**
     * 组装衍生字段的JSON处理类
     */


}
