package com.kexun.model.xml;

import com.alibaba.fastjson.annotation.JSONField;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * Description:(准)贷记卡账户信息汇总
 *
 * @author lgs
 * @date 2023/06/08
 */
@Data
public class SmryCreditCard implements IXmlBase{
    /**
     * 发卡机构数
     */
    @JSONField(name = "CARDISSUERNUM")
    private Integer cardIssuerNum;

    /**
     * 账户数
     */
    @JSONField(name = "ACCSUM")
    private Integer accSum;

    /**
     * 授信总额
     */
    @JSONField(name = "CREDITSUM")
    private BigDecimal creditSum;

    /**
     * 单家机构最高授信额
     */
    @JSONField(name = "CRAMOUNTMAX")
    private BigDecimal singleOrgMax;

    /**
     * 单家机构最低授信额
     */
    @JSONField(name = "CRAMOUNTMIN")
    private BigDecimal singleOrgMin;

    /**
     * 透支余额
     */
    @JSONField(name = "OVERDRAFT")
    private BigDecimal overdraft;

    /**
     * 已用额度
     */
    @JSONField(name = "ALREADYUSED")
    private BigDecimal creditUsed;

    /**
     * 最近6个月平均使用额度
     */
    @JSONField(name = "LATELY6MONUSE")
    private BigDecimal lately6monUsed;

    /**
     * 最近6个月平均透支余额
     */
    @JSONField(name = "LATELY6MONDRAFT")
    private BigDecimal lately6monDraft;
}
