package com.kexun.model.xml.trs;

import com.alibaba.fastjson.annotation.JSONField;
import com.baomidou.mybatisplus.annotation.TableField;
import com.kexun.model.xml.IXmlBase;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * Description:相关还款责任信息
 *
 * @author lgs
 * @date 2023/06/12
 */
@Data
public class RltRepay {
    /**
     * 记录编号
     */
    @JSONField(name = "ACCOUNTNO")
    private String accountNo;

    /**
     * 主借款人身份类别代码
     */
    @JSONField(name = "MAINBUSICERTINFOTYPECODE")
    private String mainIdType;

    /**
     * 主借款人身份类别描述
     */
    @JSONField(name = "MAINBUSICERTINFOTYPEDESC")
    private String mainIdNo;

    /**
     * 业务管理机构类型代码
     */
    @JSONField(name = "MANAGEORGTYPECODE")
    private String manageOrgTypeCode;

    /**
     * 业务管理机构类型描述
     */
    @JSONField(name = "MANAGEORGTYPEDESC")
    private String manageOrgTypeDesc;

    /**
     * 业务管理机构
     */
    @JSONField(name = "MAINBUSIORGNAME")
    private String busiOrgName;

    /**
     * 业务种类代码
     */
    @JSONField(name = "BUSILINESCODE")
    private String busiLinesCode;

    /**
     * 业务种类描述
     */
    @JSONField(name = "BUSILINESDESC")
    private String busiLinesDesc;

    /**
     * 开立日期
     */
    @JSONField(name = "MAINBUSIOPENDATE")
    private String openDate;

    /**
     * 到期日期
     */
    @JSONField(name = "MAINBUSIDUEDATE")
    private String dueDate;

    /**
     * 相关还款责任人类型代码
     */
    @JSONField(name = "ARLPTYPECODE")
    private String arlpTypeCode;

    /**
     * 相关还款责任人类型描述
     */
    @JSONField(name = "ARLPTYPEDESC")
    private String arlpTypeDesc;

    /**
     * 保证合同编号
     */
    @JSONField(name = "GUARCONNUM")
    private String guarConNum;

    /**
     * 相关还款责任金额
     */
    @JSONField(name = "RPYRESAMT")
    private BigDecimal rpyResAmt;

    /**
     * 币种代码
     */
    @JSONField(name = "MONEYTYPECODE")
    private String currencyCode;

    /**
     * 币种描述
     */
    @JSONField(name = "MONEYTYPEDESC")
    private String currencyDesc;

    /**
     * 余额
     */
    @JSONField(name = "MAINBUSIBAL")
    private BigDecimal balance;

    /**
     * 五级分类代码
     */
    @JSONField(name = "FIVECATECODE")
    private String fiveCateCode;

    /**
     * 五级分类描述
     */
    @JSONField(name = "FIVECATEDESC")
    private String fiveCateDesc;

    /**
     * 账户类型代码
     */
    @JSONField(name = "ACCTYPECODE")
    private String accTypeCode;

    /**
     * 账户类型描述
     */
    @JSONField(name = "ACCTYPEDESC")
    private String accTypeDesc;

    /**
     * 还款状态代码
     */
    @JSONField(name = "MAINRPYSTATUSCODE")
    private String rpyStatusCode;

    /**
     * 还款状态描述
     */
    @JSONField(name = "MAINRPYSTATUSDESC")
    private String rpyStatusDesc;

    /**
     * 逾期月数
     */
    @JSONField(name = "BUSIMONTH")
    private Integer overdueMonth;

    /**
     * 信息报告日期
     */
    @JSONField(name = "REPORTDATEINFO")
    private String reportDate;
}
