package com.kexun.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.kexun.entity.*;
import com.kexun.mapper.CooperatorMapper;
import com.kexun.service.CooperatorService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 *
 */
@Service
public class CooperatorServiceImpl extends ServiceImpl<CooperatorMapper, CooperatorInfo>
    implements CooperatorService {
    @Override
    public CooperatorInfo findByCooperatorNum(String partnerName) {
        QueryWrapper wrapper=new QueryWrapper();
        wrapper.eq("cooperator_name",partnerName);
        return getOne(wrapper);
    }

    @Resource
    CooperatorMapper cooperatorMapper;

    @Override
    public List<CooperatorInfo> findByCorpCertificateNumAndType(String corpCertificateNum,String corpCertificateType) {
        QueryWrapper wrapper=new QueryWrapper();
        wrapper.eq("corp_certificate_num",corpCertificateNum);
        wrapper.eq("corp_certificate_type",corpCertificateType);
        return list(wrapper);
    }

    @Override
    public List<CooperatorField> findCooperatorFieldByNum(String templateId) {
        List<CooperatorField> cooperatorFields = cooperatorMapper.queryField(templateId);
        for (CooperatorField cooperatorField : cooperatorFields) {
            if (cooperatorField.getCategory().equals("1")){
                cooperatorField.setCategory("基础字段");
            }else {
                cooperatorField.setCategory("衍生字段");
            }
        }
        return cooperatorFields;
    }

    @Override
    public List<CooperatorField> findCooperatorFieldByCooNum(String cooperatorNum) {
        List<CooperatorField> l = cooperatorMapper.queryByCooNum(cooperatorNum);
        for (CooperatorField cooperatorField : l) {
            if (cooperatorField.getCategory().equals("1")){
                cooperatorField.setCategory("基础字段");
            }else {
                cooperatorField.setCategory("衍生字段");
            }
        }
        return l;
    }

    @Override
    public List<CooperatorProduct> findCooperatorProductByNum(String cooperatorNum) {
//        System.out.println("aaa");
        List<CooperatorProduct> l = cooperatorMapper.QueryProduct(cooperatorNum);
        return l;
    }

    public List<CooperatorInfo> selectPage() {
        List<CooperatorInfo> l = cooperatorMapper.selectAll();
        return l;
    }

    public List<CooperatorInfo> selectCoop(String info) {
        List<CooperatorInfo> l = cooperatorMapper.selectCoop(info);
        return l;
    }
    @Override
    public CooperatorInfo findByID(long id) {
        QueryWrapper<CooperatorInfo> wrapper=new QueryWrapper<CooperatorInfo>().eq("id",id);
        return getOne(wrapper);
    }

}




