package com.kexun.service.impl;

import com.kexun.entity.CrHeadInfEntity;
import com.kexun.mapper.CrHeadInfMapper;
import com.kexun.model.xml.HeadInfo;
import com.kexun.service.CrHeadInfService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.kexun.utils.DateUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 报告头信息 服务实现类
 * </p>
 *
 * @author lgs
 * @since 2023-05-26
 */
@Service
public class CrHeadInfServiceImpl extends ServiceImpl<CrHeadInfMapper, CrHeadInfEntity> implements CrHeadInfService {


    @Autowired
    CrHeadInfMapper crHeadInfMapper;

    /**
     * 保存报文头信息
     * @param headInfo
     * @return
     */
    @Override
    public Long saveHeadInfo(HeadInfo headInfo) {
        CrHeadInfEntity crHeadInfEntity = new CrHeadInfEntity();
        BeanUtils.copyProperties(headInfo,crHeadInfEntity);
        crHeadInfEntity.setRptTime(DateUtils.convertStrToDate(DateUtils.convertTDate(headInfo.getRptTime()),DateUtils.DATE_YYYY_MM_DD_HH_MM_SS));
        crHeadInfMapper.insert(crHeadInfEntity);
        return crHeadInfEntity.getId();
    }

    /**
     * 保存或者修改报文头信息
     * @param crHeadInfEntity
     * @return
     */
    @Override
    public Long saveUpdateHeadInfo(CrHeadInfEntity crHeadInfEntity) {
        super.saveOrUpdate(crHeadInfEntity);
        return crHeadInfEntity.getId();
    }


}
