package com.kexun.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.kexun.common.Model;
import com.kexun.entity.ModelEntity;
import com.kexun.mapper.UserModelMapper;
import com.kexun.service.UserModelService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
@Service
public class UserModelServiceImpl extends ServiceImpl<UserModelMapper, ModelEntity>
        implements UserModelService
{
    @Resource
    UserModelMapper userModelMapper;

//    public String getModelNoService(String userName) {
//        QueryWrapper<ModelEntity> wrapper = new QueryWrapper<ModelEntity>()
//                .eq("create_by", userName)
//                .orderByDesc("id")
//                .last("LIMIT 1");
//
//        ModelEntity lastModel = modelMapper.selectOne(wrapper);
//
//        if (lastModel != null) {
//            return lastModel.getModelNo();
//        } else {
//            return null; // or handle the case when no data is found
//        }
//    }
    @Override
    public List<ModelEntity> findByUserName(String user_name) {

        QueryWrapper<ModelEntity> wrapper=new QueryWrapper<ModelEntity>().eq("create_by",user_name);
        List<ModelEntity> model_Entity_list =list(wrapper);
        return model_Entity_list;
    }

    @Override
    public ModelEntity findByModelName(String model_name)
    {
        QueryWrapper<ModelEntity> wrapper=new QueryWrapper<ModelEntity>().eq("model_name",model_name);

        return getOne(wrapper);

    }
    @Override

    public ModelEntity findByUserAndModel(String user_name, String model_name)
    {
        QueryWrapper<ModelEntity> wrapper=new QueryWrapper<ModelEntity>().eq("create_by",user_name);
        wrapper.eq("model_name",model_name);
        return getOne(wrapper);

    }

    @Override
    public ModelEntity findByID(long id) {
        QueryWrapper<ModelEntity> wrapper=new QueryWrapper<ModelEntity>().eq("id",id);
        return getOne(wrapper);
    }

    @Override
    public void removeModelByID(long id) {
        QueryWrapper<ModelEntity> wrapper=new QueryWrapper<ModelEntity>().eq("id",id);
        remove(wrapper);
    }
    @Override
    public void changeModelName(String modelName,long modelNo){
        userModelMapper.changeModelNameQuery(modelName,modelNo);
    }
    @Override
    public List<ModelEntity> getUserModel(){
        return userModelMapper.getUserModelQuery();
    }

    @Override
    public String getModelNo(){
        return userModelMapper.getModelNo();
    }

}
